<script src="@#file#(webgl-math.js)" type="text/javascript"></script>

<p>
  Rezimirajmo karakteristike svakog od opisanih modela sjenčanja.
</p>
<ul>
  <li>
    Konstantno sjenčanje ima najmanji računski trošak. Uporabom modela osvjetljavanja računa se osvjetljenje samo za jednu
    točku poligona, i tako se izračunata boja koristi za sve slikovne elemente pri rasterizaciji
    poligona.
  </li>
  <li>
    Gouraudovo sjenčanje ima veći računski trošak. Potrebno je primjenom modela osvjetljavanja
    izračunati intenzitete ("boje") u svim vrhovima poligona. Potom je te intenzitete potrebno
    interpolirati po bridovima (kako se mijenja <i>y</i>-koordinata skenirajuće zrake) i potom 
    uzduž skenirajuće zrake između <i>x</i><sub>L</sub> i <i>x</i><sub>D</sub>.  U novijim 
    inačicama OpenGL-a, ovaj se izračun provodi u sjenčaru vrhova.
  </li>
  <li>
    Phongovo sjenčanje ima najveći računski trošak. Potrebno je provesti interpolacije normala
    i koordinata točaka površine poligona po bridovima i zatim po uzduž skenirajuće zrake. Za svaki
    konkretan slikovni element na temelju interpolirane normale i položaja pripadne točke u cijelosti
    se uporabom modela osvjetljavanja računa boja kojom će biti osvijetljen slikovni element.
    U novijim inačicama OpenGL-a, ovaj se postupak provodi u sjenčarima fragmenata.
  </li>
</ul>

<p>
  U nastavku je dan primjer generiranja prikaza scene sastavljene od kugle i dva elipsoida čija
  su oplošja poligonizirana na različite načine: najprije grubo, potom nešto finije i na kraju još 
  finije. Za svaki takav model, scena je obojana uporabom sva tri opisana načina sjenčanja. 
</p>

<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s3-konst.png)">
<figcaption>Slika 1. Grubi model oplošja. Konstantno sjenčanje.</figcaption>
</figure>
<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s3-gour.png)">
<figcaption>Slika 2. Grubi model oplošja. Gouraudovo sjenčanje.</figcaption>
</figure>
<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s3-phong.png)">
<figcaption>Slika 3. Grubi model oplošja. Phongovo sjenčanje.</figcaption>
</figure>

<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s4-konst.png)">
<figcaption>Slika 4. Detaljniji model oplošja. Konstantno sjenčanje.</figcaption>
</figure>
<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s4-gour.png)">
<figcaption>Slika 5. Detaljniji model oplošja. Gouraudovo sjenčanje.</figcaption>
</figure>
<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s4-phong.png)">
<figcaption>Slika 6. Detaljniji model oplošja. Phongovo sjenčanje.</figcaption>
</figure>

<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s6-konst.png)">
<figcaption>Slika 7. Još detaljniji model oplošja. Konstantno sjenčanje.</figcaption>
</figure>
<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s6-gour.png)">
<figcaption>Slika 8. Još detaljniji model oplošja. Gouraudovo sjenčanje.</figcaption>
</figure>
<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(s6-phong.png)">
<figcaption>Slika 9. Još detaljniji model oplošja. Phongovo sjenčanje.</figcaption>
</figure>

<p>
 Na slici 2 može se primjetiti jedan od problema koje ima Gouraudovo sjenčanje. Ako su
 poligoni veći, a dogodi se da je odbljesak fokusiran u centru poligona, moguće je da isti uopće ne
 bude zabilježen. Naime, efekt odbljeska opada kako se pomičemo od centra, i dok dođemo
 do vrhova poligona, može postati nezamjetan. A to je problem, jer Gouraudovo sjenčanje 
 intenzitete računa samo u vrhovima i potom ih interpolira po površini poligona. Kako niti
 u jednom vrhu odbljesak nije zabilježen, neće ga biti ni u interpolaciji.
</p>

